SystemOrganization addCategory: #'OB-TraitsIntegration'!
SystemOrganization addCategory: #'OB-TraitsIntegration-Commands'!
SystemOrganization addCategory: #'OB-TraitsIntegration-Filters'!
SystemOrganization addCategory: #'OB-TraitsIntegration-Nodes'!
SystemOrganization addCategory: #'OB-TraitsIntegration-Traits'!

Trait named: #OBTParentNode
	uses: {}
	category: 'OB-TraitsIntegration-Traits'!

!OBTParentNode classSide methodsFor: 'instance creation' stamp: 'jk 8/14/2007 08:03'!
on: aNestedObject of: aParentNode
	^ self new on: aNestedObject of: aParentNode! !

!OBTParentNode methodsFor: 'accessing' stamp: 'jk 8/23/2007 18:53'!
nestedObject
	self explicitRequirement ! !

!OBTParentNode methodsFor: 'accessing' stamp: 'jk 8/23/2007 18:53'!
nestedObject: anObject
	self explicitRequirement ! !

!OBTParentNode methodsFor: 'public' stamp: 'jk 8/20/2007 15:30'!
numberOfPredecessors
	^ self parentNode numberOfPredecessors + 1! !

!OBTParentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 08:03'!
on: aNestedObject of: aParentNode
	self parentNode: aParentNode.
	self nestedObject: aNestedObject! !

!OBTParentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 08:02'!
parentNode
	self explicitRequirement ! !

!OBTParentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 08:02'!
parentNode: anObject
	self explicitRequirement! !

!OBTParentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 09:01'!
theClass
	^ self parentNode theClass! !

!OBTParentNode methodsFor: 'public' stamp: 'jk 8/14/2007 08:56'!
withAllParents
	^ (OrderedCollection new)
		add: self nestedObject;
		addAll: self parentNode withAllParents;
		yourself! !

!TCommentDescription methodsFor: '*ob-traitsIntegration' stamp: 'dc 4/21/2007 15:34'!
asCommentNode
	^ OBClassCommentNode on: self theNonMetaClass 
! !

OBClassCommentNode subclass: #OBTraitTransformationCommentNode
	uses: OBTParentNode
	instanceVariableNames: 'parentNode transformation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-TraitsIntegration-Nodes'!

OBTraitTransformationCommentNode class
	uses: OBTParentNode classTrait
	instanceVariableNames: ''!

!OBTraitTransformationCommentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 11:26'!
nestedObject
	^ transformation! !

!OBTraitTransformationCommentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 11:26'!
nestedObject: anObject
	transformation := anObject! !

!OBTraitTransformationCommentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 11:27'!
parentNode
	^ parentNode! !

!OBTraitTransformationCommentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 11:27'!
parentNode: anObject
	parentNode := anObject! !

OBClassCommentNode subclass: #OBUsedTraitCommentNode
	uses: OBTParentNode - {#theClass}
	instanceVariableNames: 'parentNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-TraitsIntegration-Nodes'!

OBUsedTraitCommentNode class
	uses: OBTParentNode classTrait
	instanceVariableNames: ''!

!OBUsedTraitCommentNode methodsFor: 'accessing' stamp: 'jk 8/23/2007 18:01'!
nestedObject
	^ self theClass! !

!OBUsedTraitCommentNode methodsFor: 'accessing' stamp: 'jk 8/23/2007 18:01'!
nestedObject: anObject
	self theClass: anObject ! !

!OBUsedTraitCommentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 11:46'!
parentNode
	^ parentNode! !

!OBUsedTraitCommentNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 11:47'!
parentNode: anObject
	parentNode := anObject ! !

!Trait methodsFor: '*ob-traitsIntegration' stamp: 'dc 4/21/2007 15:34'!
asClassSideNode
	^ OBMetaclassNode on: self
! !

!Trait methodsFor: '*ob-traitsIntegration' stamp: 'jk 8/20/2007 12:14'!
asClassSideNodeOf: aParentNode 
	^ OBUsedTraitMetaclassNode on: self of: aParentNode! !

!Trait methodsFor: '*ob-traitsIntegration' stamp: 'dc 4/21/2007 15:35'!
asNode
	^ OBClassNode on: self
! !

!Trait methodsFor: '*ob-traitsIntegration' stamp: 'jk 8/14/2007 08:09'!
asNodeOf: aParentNode
	^ OBUsedTraitNode on: self of: aParentNode! !

!OBMetagraphBuilder methodsFor: '*ob-traitsintegration-private' stamp: 'jk 8/23/2007 21:15'!
populateTraitFilter
	| classesWithUsedTraits |
	classesWithUsedTraits := OBMetaNode named: 'ClassWithUsedTraits'.
	root 
		childAt: classSel
		labeled: 'traits'
		put: classesWithUsedTraits.
	classesWithUsedTraits
		childAt: #usedTraits
			labeled: 'instance'
			put: class;
		childAt: #commentsOfUsedTraits
			labeled: '?'
			put: comment;
		childAt: #metaclassesOfUsedTraits
			labeled: 'class'
			put: metaclass;
		addFilter: OBModalFilter new;
		addFilter: OBTraitSortFilter new.! !

!ClassTrait methodsFor: '*ob-traitsIntegration' stamp: 'dc 4/21/2007 15:33'!
asClassSideNode
	^ OBMetaclassNode on: self baseTrait
! !

!ClassTrait methodsFor: '*ob-traitsIntegration' stamp: 'jk 8/23/2007 16:59'!
asClassSideNodeOf: aParentNode 
	^ OBUsedTraitMetaclassNode on: self of: aParentNode! !

!ClassTrait methodsFor: '*ob-traitsIntegration' stamp: 'dc 4/21/2007 15:33'!
asNode
	^ OBMetaclassNode on: self
! !

!ClassTrait methodsFor: '*ob-traitsIntegration' stamp: 'jk 8/23/2007 16:57'!
asNodeOf: aParentNode
	^ OBUsedTraitNode on: self of: aParentNode! !

OBMetaclassNode subclass: #OBTraitTransformationMetaclassNode
	uses: OBTParentNode
	instanceVariableNames: 'parentNode transformation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-TraitsIntegration-Nodes'!

OBTraitTransformationMetaclassNode class
	uses: OBTParentNode classTrait
	instanceVariableNames: ''!

!OBTraitTransformationMetaclassNode methodsFor: 'accessing' stamp: 'jk 8/20/2007 15:00'!
nestedObject
	transformation ! !

!OBTraitTransformationMetaclassNode methodsFor: 'accessing' stamp: 'jk 8/20/2007 15:00'!
nestedObject: anObject
	transformation := anObject ! !

!OBTraitTransformationMetaclassNode methodsFor: 'accessing' stamp: 'jk 8/20/2007 15:00'!
parentNode
	parentNode ! !

!OBTraitTransformationMetaclassNode methodsFor: 'accessing' stamp: 'jk 8/20/2007 15:00'!
parentNode: anObject
	parentNode := anObject ! !

OBMetaclassNode subclass: #OBUsedTraitMetaclassNode
	uses: OBTParentNode - {#theClass}
	instanceVariableNames: 'parentNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-TraitsIntegration-Nodes'!

OBUsedTraitMetaclassNode class
	uses: OBTParentNode classTrait
	instanceVariableNames: ''!

!OBUsedTraitMetaclassNode methodsFor: 'accessing' stamp: 'jk 8/23/2007 18:30'!
nestedObject
	^ self theClass! !

!OBUsedTraitMetaclassNode methodsFor: 'accessing' stamp: 'jk 8/23/2007 18:30'!
nestedObject: anObject
	self theClass: anObject ! !

!OBUsedTraitMetaclassNode methodsFor: 'accessing' stamp: 'jk 8/20/2007 12:12'!
parentNode
	^ parentNode! !

!OBUsedTraitMetaclassNode methodsFor: 'accessing' stamp: 'jk 8/20/2007 12:12'!
parentNode: anObject
	parentNode := anObject ! !

!OBMethodDefinition methodsFor: '*ob-traitsintegration-confirming' stamp: 'jk 8/23/2007 20:27'!
confirmCompileLocalyOrInUsedTrait: aTrait 
	| result prompt m1 m2 m3 r1 r3 |
	prompt := 'You are compiling a method that already exists in a
used trait. What do you want to do:' translated.
	r1 := self compileClass.
	r3 := nil.
	m1 := 'Compile the method locally in ' translated , r1 asString.
	m2 := 'Compile the method in the trait ' translated , aTrait asString.
	m3 := 'Cancel' translated.
	result := OBChoiceRequest
				prompt: prompt
				labels: (Array with: m1 with: m2 with: m3)
				values: (Array with: r1 with: aTrait with: r3 ).
	result = aTrait
		ifTrue: [self compileClass: aTrait].
	result isNil
		ifTrue: [^ false].
	^ true! !

!OBMethodDefinition methodsFor: '*ob-traitsintegration-validation' stamp: 'jk 8/22/2007 19:48'!
validateMethodOfUsedTrait
	| messageLocation |
	
	messageLocation := self compileClass traitOrClassOfSelector: self compileSelector.
	self compileClass = messageLocation ifTrue: [^ true]. "it is local message"
	messageLocation isTrait ifTrue: 
		[^ self confirmCompileLocalyOrInUsedTrait: messageLocation ].
	^ true! !

!OBClassNode methodsFor: '*ob-traitsintegration-navigating' stamp: 'jk 8/14/2007 11:37'!
addTraitsOf: aClassOrTrait bySelector: aSelector into: aCollection ofParentNode: aNode 
	aClassOrTrait traitTransformations
		do: [:t | 
			| n | 
			n := t asNodeOf: aNode.
			aCollection
				add: (t perform: aSelector with: aNode).
			self
				addTraitsOf: t
				bySelector: aSelector
				into: aCollection
				ofParentNode: n].
	^ aCollection! !

!OBClassNode methodsFor: '*ob-traitsintegration-navigating' stamp: 'jk 8/23/2007 17:11'!
commentsOfUsedTraits
	| result root |
	result := OrderedCollection new.
	root := self theClass asCommentNode.
	result add: root.
	self addTraitsOf: self theClass bySelector: #asCommentNodeOf: into: result ofParentNode: root.
	^ result! !

!OBClassNode methodsFor: '*ob-traitsintegration-navigating' stamp: 'jk 8/23/2007 16:54'!
metaclassesOfUsedTraits
	| result root |
	result := OrderedCollection new.
	root := self theClass asClassSideNode.
	result add: root.
	self
		addTraitsOf: root theClass
		bySelector: #asClassSideNodeOf:
		into: result
		ofParentNode: root.
	^ result! !

!OBClassNode methodsFor: '*ob-traitsintegration-navigating' stamp: 'jk 8/23/2007 17:11'!
usedTraits
	| result root |
	result := OrderedCollection new.
	root := self copy.
	result add: root.
	self addTraitsOf: self theClass bySelector: #asNodeOf: into: result ofParentNode: root.
	^ result! !

OBClassNode subclass: #OBTraitTransformationNode
	uses: OBTParentNode
	instanceVariableNames: 'parentNode transformation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-TraitsIntegration-Nodes'!

OBTraitTransformationNode class
	uses: OBTParentNode classTrait
	instanceVariableNames: ''!

!OBTraitTransformationNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 08:52'!
nestedObject
	^ transformation! !

!OBTraitTransformationNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 08:52'!
nestedObject: anObject
	transformation := anObject! !

!OBTraitTransformationNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 08:51'!
parentNode
	^ parentNode! !

!OBTraitTransformationNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 08:51'!
parentNode: anObject
	parentNode := anObject! !

OBClassNode subclass: #OBUsedTraitNode
	uses: OBTParentNode - {#theClass}
	instanceVariableNames: 'parentNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-TraitsIntegration-Nodes'!

OBUsedTraitNode class
	uses: OBTParentNode classTrait
	instanceVariableNames: ''!

!OBUsedTraitNode methodsFor: 'accessing' stamp: 'jk 8/23/2007 17:57'!
nestedObject
	^ self theClass! !

!OBUsedTraitNode methodsFor: 'accessing' stamp: 'jk 8/23/2007 17:58'!
nestedObject: anObject
	self theClass: anObject! !

!OBUsedTraitNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 08:07'!
parentNode
	^ parentNode! !

!OBUsedTraitNode methodsFor: 'accessing' stamp: 'jk 8/14/2007 08:07'!
parentNode: anObject
	parentNode := anObject ! !

!TraitTransformation methodsFor: '*ob-traitsIntegration' stamp: 'jk 8/20/2007 15:13'!
asClassSideNodeOf: aParentNode 
	^ OBTraitTransformationMetaclassNode on: self of: aParentNode! !

!TraitTransformation methodsFor: '*ob-traitsIntegration' stamp: 'jk 8/14/2007 11:42'!
asCommentNodeOf: aParentNode 
	^ OBTraitTransformationCommentNode on: self of: aParentNode! !

!TraitTransformation methodsFor: '*ob-traitsIntegration' stamp: 'jk 8/14/2007 08:53'!
asNodeOf: aParentNode
	^ OBTraitTransformationNode on: self of: aParentNode! !

OBCmdClassTemplate subclass: #OBCmdNewTraitTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-TraitsIntegration'!

!OBCmdNewTraitTemplate methodsFor: 'accessing' stamp: 'dc 4/23/2007 15:03'!
label
	^ 'new trait template'! !

!OBCmdNewTraitTemplate methodsFor: 'private' stamp: 'dc 7/22/2007 21:04'!
templateDefinition
	^ OBClassDefinition 
			environment: self currentEnvironment
			template: (Trait newTemplateIn: self currentCategory)! !

!OBCmdFindClass class methodsFor: '*ob-traitsIntegration' stamp: 'dc 5/17/2007 12:57'!
on: target for: requestor
	^ OBCmdFindClassOrTrait new setTarget: target requestor: requestor! !

OBCmdFindClass subclass: #OBCmdFindClassOrTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-TraitsIntegration'!

!OBCmdFindClassOrTrait methodsFor: 'private' stamp: 'dc 5/17/2007 12:54'!
allBehaviorsIn: anEnvironment
	^ Array streamContents: [:stream|
		
		stream
			nextPutAll: anEnvironment classNames;
			nextPutAll: anEnvironment traitNames 
		
		]! !

!OBClassAwareNode methodsFor: '*ob-traitsIntegration' stamp: 'jk 8/20/2007 15:33'!
numberOfPredecessors
	^ 0! !

!OBClassAwareNode methodsFor: '*ob-traitsIntegration' stamp: 'jk 8/14/2007 08:57'!
withAllParents
	^ (OrderedCollection new)
		add: self theClass;
		yourself! !

!OBClassCategoryNode methodsFor: '*ob-traitsintegration' stamp: 'jk 8/13/2007 16:23'!
addTraitsOf: aClassOrTrait into: aCollection ofParentNode: aNode
	aClassOrTrait traitTransformations do: [ :t | | n |
			n := t asNodeOf: aNode.
			aCollection add: (t asNodeOf: aNode).
			self addTraitsOf: t into: aCollection ofParentNode: n.
		].
	^ aCollection
! !

!OBClassCategoryNode methodsFor: '*ob-traitsintegration' stamp: 'jk 8/13/2007 16:23'!
usedTraits
	| classes result |
	classes := self classes.
	result := OrderedCollection new.
	classes do: [ :node |
				result add: node.
				self addTraitsOf: node theClass into: result ofParentNode: node. ].
	^ result! !

OBFilter subclass: #OBTraitSortFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-TraitsIntegration-Filters'!

!OBTraitSortFilter methodsFor: 'filtering' stamp: 'jk 8/20/2007 15:37'!
displayString: aString forParent: pNode child: cNode
	^ (String new: cNode numberOfPredecessors withAll: $ ), aString! !

!OBCodeBrowser methodsFor: '*ob-traitsIntegration' stamp: 'jk 6/20/2007 17:23'!
cmdBrowseMethodImplementor
	^ OBCmdBrowseMethodImplementor! !

!OBCodeBrowser methodsFor: '*ob-traitsIntegration' stamp: 'ab 6/5/2007 23:50'!
cmdBrowseTraitUser
	^OBCmdBrowseTraitUsers! !

!OBCodeBrowser methodsFor: '*ob-traitsIntegration' stamp: 'dc 4/23/2007 15:04'!
cmdNewTraitTemplate
	^ OBCmdNewTraitTemplate ! !

!OBCodeBrowser methodsFor: '*ob-traitsIntegration' stamp: 'jk 8/25/2007 16:26'!
cmdTraitsIntegration
	^ OBCmdTraitsIntegration allSubclasses! !

!OBMethodNode methodsFor: '*ob-traitsIntegration' stamp: 'jk 8/25/2007 17:14'!
comesFrom
	^ self theClass traitOrClassOfSelector: self selector! !

!OBMethodNode methodsFor: '*ob-traitsIntegration' stamp: 'jk 8/25/2007 20:31'!
comesFromName
	^ self comesFrom asString! !

!OBMethodNode methodsFor: '*ob-traitsIntegration' stamp: 'jk 8/25/2007 17:41'!
comesFromTrait
	^ self comesFrom isTrait! !

!OBMethodNode methodsFor: '*ob-traitsIntegration' stamp: 'jk 8/25/2007 21:29'!
confirmSelectorExclusion
	| senders prompt m1 m2 m3 |
	senders := SystemNavigation default allCallsOn: self selector.
	prompt := 'The selector you want to remove comes from a trait.
What do you want to do:' translated.
	m1 := 'Exclude selector from use in the class ' translated , self theClassName.
	m2 := 'Remove selector in the trait ' translated , self comesFromName , ' (' , senders size asString , ' senders' translated , ')'.
	m3 := 'Cancel' translated.
	^ OBChoiceRequest
		prompt: prompt
		labels: (Array
				with: m1
				with: m2
				with: m3)
		values: #(#doExcludeSelector #removeFromTrait nil )! !

!OBMethodNode methodsFor: '*ob-traitsIntegration' stamp: 'jk 8/25/2007 20:32'!
doExcludeSelector
	| traits composition |
	traits := self theClass traitComposition traits
				select: [:each | each canUnderstand: self selector].
	composition := traits
				inject: self theClass traitComposition
				into: [:newComposition :each | newComposition copyWithExclusionOf: self selector to: each].
	self theClass setTraitComposition: composition asTraitComposition.
	self signalDeletion! !

!OBMethodNode methodsFor: '*ob-traitsIntegration' stamp: 'jk 8/25/2007 20:34'!
doNothing! !

!OBMethodNode methodsFor: '*ob-traitsIntegration' stamp: 'jk 8/25/2007 21:08'!
excludeSelector
	| r |
	r := self confirmSelectorExclusion.
	r ifNotNil: [self perform: r]! !

!OBMethodNode methodsFor: '*ob-traitsIntegration' stamp: 'jk 8/25/2007 21:30'!
removeFromTrait
	self comesFrom removeSelector: self selector.
	self signalDeletion! !

!TraitDescription methodsFor: '*ob-traitsIntegration' stamp: 'jk 8/20/2007 12:24'!
asCommentNodeOf: aParentNode 
	^ OBUsedTraitCommentNode on: self of: aParentNode! !

!OBAnnotationRequest methodsFor: '*ob-traitsIntegration' stamp: 'jk 6/20/2007 14:03'!
messageComesFrom
	class isNil ifTrue: [^ String new].
	selector isNil ifTrue: [^ class printString ].
	^ (class traitOrClassOfSelector: selector) printString! !

OBCommand subclass: #OBCmdBrowseMethodImplementor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-TraitsIntegration'!

!OBCmdBrowseMethodImplementor methodsFor: 'execution' stamp: 'jk 6/20/2007 16:33'!
execute
	| class |
	class := target theClass traitOrClassOfSelector: target selector.
	(OBMethodNode on: target selector inClass: class) browse! !

!OBCmdBrowseMethodImplementor methodsFor: 'accessing' stamp: 'jk 6/20/2007 16:34'!
group
	^ #navigation! !

!OBCmdBrowseMethodImplementor methodsFor: 'testing' stamp: 'jk 6/20/2007 16:28'!
isActive
	^ (target isKindOf: OBMethodNode)
		and: [requestor isSelected: target]! !

!OBCmdBrowseMethodImplementor methodsFor: 'accessing' stamp: 'jk 6/20/2007 16:38'!
keystroke
	^ $M! !

!OBCmdBrowseMethodImplementor methodsFor: 'accessing' stamp: 'jk 6/20/2007 16:27'!
label
	^ 'browse method implementor'! !

OBCommand subclass: #OBCmdBrowseTraitUsers
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-TraitsIntegration'!

!OBCmdBrowseTraitUsers methodsFor: 'execution' stamp: 'ab 6/6/2007 00:00'!
execute
	| users usersNames selection |
	"ugly hack to get rid of double..."
	users := target theClass users asOrderedCollection asSet asOrderedCollection.
	(users size = 0)
		ifTrue: [Beeper beep. ^ self].
	(users size = 1)
		ifTrue: [users first browse. ^ self].
		
	usersNames := users asOrderedCollection collect: [:clsOrTrait| clsOrTrait name].
	selection := OBChoiceRequest prompt: nil labels: usersNames values: users.
	selection ifNotNil: [selection browse].! !

!OBCmdBrowseTraitUsers methodsFor: 'testing' stamp: 'ab 6/5/2007 23:52'!
isActive

	^ ((target isKindOf: OBClassNode) and: 
		[target theClass isTrait]) and:
			[requestor isSelected: target]! !

!OBCmdBrowseTraitUsers methodsFor: 'accessing' stamp: 'ab 6/5/2007 23:48'!
keystroke
	^ $u! !

!OBCmdBrowseTraitUsers methodsFor: 'accessing' stamp: 'ab 6/5/2007 23:48'!
label
	^ 'browse trait users...'! !

OBCommand subclass: #OBCmdTraitsIntegration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-TraitsIntegration-Commands'!

OBCmdTraitsIntegration subclass: #OBCmdExcludeMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-TraitsIntegration-Commands'!

!OBCmdExcludeMethod methodsFor: 'as yet unclassified' stamp: 'jk 8/25/2007 20:28'!
execute
	target excludeSelector! !

!OBCmdExcludeMethod methodsFor: 'as yet unclassified' stamp: 'jk 8/25/2007 20:50'!
icon
	^ #deleteIcon! !

!OBCmdExcludeMethod methodsFor: 'as yet unclassified' stamp: 'jk 8/25/2007 16:44'!
isActive
	^(target isKindOf: OBMethodNode) and:
		[requestor isSelected: target] and:
		[ target isLocalSelector not ]! !

!OBCmdExcludeMethod methodsFor: 'as yet unclassified' stamp: 'jk 8/25/2007 20:50'!
keystroke
	^ $x! !

!OBCmdExcludeMethod methodsFor: 'as yet unclassified' stamp: 'jk 8/25/2007 20:51'!
label
	^ 'exclude/remove...'! !
